blob: 24fd87ed0475f5ca939f20ebca6dba83e28dc429 [file] [log] [blame]
Peter Stuge09377b72011-08-21 06:24:55 +02001#!/bin/sh
Stefan Reinauer074d9132009-09-26 16:43:17 +00002#
Stefan Reinauer5f1ad892010-05-17 11:02:25 +00003# Copyright (C) 2008-2010 by coresystems GmbH
Stefan Reinauer074d9132009-09-26 16:43:17 +00004# written by Patrick Georgi <patrick.georgi@coresystems.de> and
5# Stefan Reinauer <stefan.reinauer@coresystems.de>
Stefan Reinauer14e22772010-04-27 06:56:47 +00006#
Marc Jones2aac3f62011-08-08 16:07:50 -06007# Copyright (C) 2011 by Sage Electronic Engineering
8#
Stefan Reinauer074d9132009-09-26 16:43:17 +00009# This program is free software; you can redistribute it and/or modify
10# it under the terms of the GNU General Public License as published by
11# the Free Software Foundation; version 2 of the License.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
Stefan Reinauer074d9132009-09-26 16:43:17 +000018
Stefan Reinauerd7649122015-06-09 11:44:25 -070019cd $(dirname $0)
Patrick Georgi8135dba2015-03-17 21:05:20 +010020
Iru Cai03353de2016-10-29 23:37:42 +080021CROSSGCC_DATE="March 3rd, 2017"
22CROSSGCC_VERSION="1.44"
Stefan Reinauer88352d72016-04-06 15:57:03 -070023CROSSGCC_COMMIT=$( git describe )
Stefan Reinauer074d9132009-09-26 16:43:17 +000024
25# default settings
Stefan Reinauer85b07d62015-06-09 14:45:14 -070026PACKAGE=GCC
Stefan Reinauerd7649122015-06-09 11:44:25 -070027TARGETDIR=$(pwd)/xgcc
Stefan Reinauer074d9132009-09-26 16:43:17 +000028TARGETARCH=i386-elf
Nico Huber66c2c1a2016-09-20 13:09:29 +020029DEFAULT_LANGUAGES=c
30LANGUAGES=
Stefan Reinauer074d9132009-09-26 16:43:17 +000031DESTDIR=
Stefan Reinauer85b07d62015-06-09 14:45:14 -070032SAVETEMPS=0
33SKIPPYTHON=1
Nico Huber234d2462016-01-26 16:10:17 +010034BOOTSTRAP=0
Martin Roth2c6a8062016-11-14 11:58:39 -070035THREADS=1
Stefan Reinauer074d9132009-09-26 16:43:17 +000036
Stefan Reinauer699ac272015-06-05 12:43:28 -070037# GCC toolchain version numbers
Iru Cai03353de2016-10-29 23:37:42 +080038GMP_VERSION=6.1.2
39MPFR_VERSION=3.1.5
Paul Menzele6619422015-02-23 10:33:59 +010040MPC_VERSION=1.0.3
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000041LIBELF_VERSION=0.8.13
Iru Cai03353de2016-10-29 23:37:42 +080042GCC_VERSION=6.3.0
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070043GCC_AUTOCONF_VERSION=2.69
Iru Cai03353de2016-10-29 23:37:42 +080044BINUTILS_VERSION=2.28
45GDB_VERSION=7.12
46IASL_VERSION=20161222
Stefan Reinauer3dc5d072016-04-21 19:29:03 -070047PYTHON_VERSION=3.5.1
Stefan Reinauer498f3d02016-04-21 18:10:15 -070048EXPAT_VERSION=2.1.1
Stefan Reinauer14ce2132015-06-05 13:01:13 -070049# CLANG version number
Iru Cai03353de2016-10-29 23:37:42 +080050CLANG_VERSION=3.9.1
Martin Roth589ef9d2016-08-11 18:35:06 -060051MAKE_VERSION=4.2.1
Stefan Reinauer074d9132009-09-26 16:43:17 +000052
Stefan Reinauer699ac272015-06-05 12:43:28 -070053# GCC toolchain archive locations
Martin Roth1484c032016-03-08 09:37:14 -070054# These are sanitized by the jenkins toolchain test builder, so if
55# a completely new URL is added here, it probably needs to be added
56# to the jenkins build as well, or the builder won't download it.
Stefan Reinauerd9d21022016-04-21 18:16:30 -070057GMP_ARCHIVE="http://ftpmirror.gnu.org/gmp/gmp-${GMP_VERSION}.tar.xz"
58MPFR_ARCHIVE="http://ftpmirror.gnu.org/mpfr/mpfr-${MPFR_VERSION}.tar.xz"
Idwer Vollering7962fc72012-10-25 02:14:09 +020059MPC_ARCHIVE="http://ftpmirror.gnu.org/mpc/mpc-${MPC_VERSION}.tar.gz"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000060LIBELF_ARCHIVE="http://www.mr511.de/software/libelf-${LIBELF_VERSION}.tar.gz"
Idwer Vollering1cfee0b2012-10-25 02:03:53 +020061GCC_ARCHIVE="http://ftpmirror.gnu.org/gcc/gcc-${GCC_VERSION}/gcc-${GCC_VERSION}.tar.bz2"
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070062BINUTILS_ARCHIVE="http://ftpmirror.gnu.org/binutils/binutils-${BINUTILS_VERSION}.tar.bz2"
Patrick Georgi53c388f2015-03-07 09:55:18 +010063GDB_ARCHIVE="http://ftpmirror.gnu.org/gdb/gdb-${GDB_VERSION}.tar.xz"
Patrick Georgi85bb9462016-02-11 17:22:16 +010064IASL_ARCHIVE="https://acpica.org/sites/acpica/files/acpica-unix2-${IASL_VERSION}.tar.gz"
Patrick Georgi53c388f2015-03-07 09:55:18 +010065PYTHON_ARCHIVE="http://www.python.org/ftp/python/${PYTHON_VERSION}/Python-${PYTHON_VERSION}.tar.xz"
Stefan Reinauer498f3d02016-04-21 18:10:15 -070066EXPAT_ARCHIVE="http://downloads.sourceforge.net/sourceforge/expat/expat-${EXPAT_VERSION}.tar.bz2"
Stefan Reinauer14ce2132015-06-05 13:01:13 -070067# CLANG toolchain archive locations
68LLVM_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/llvm-${CLANG_VERSION}.src.tar.xz"
69CFE_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/cfe-${CLANG_VERSION}.src.tar.xz"
70CRT_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/compiler-rt-${CLANG_VERSION}.src.tar.xz"
71CTE_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/clang-tools-extra-${CLANG_VERSION}.src.tar.xz"
Stefan Reinauera851bbb2016-01-29 18:03:26 -080072MAKE_ARCHIVE="http://ftpmirror.gnu.org/make/make-${MAKE_VERSION}.tar.bz2"
Stefan Reinauer074d9132009-09-26 16:43:17 +000073
Martin Roth58c68d52016-03-01 15:22:42 -070074ALL_ARCHIVES="$GMP_ARCHIVE $MPFR_ARCHIVE $MPC_ARCHIVE $LIBELF_ARCHIVE \
75 $GCC_ARCHIVE $BINUTILS_ARCHIVE $GDB_ARCHIVE $IASL_ARCHIVE \
76 $PYTHON_ARCHIVE $EXPAT_ARCHIVE $LLVM_ARCHIVE $CFE_ARCHIVE \
77 $CRT_ARCHIVE $CTE_ARCHIVE $MAKE_ARCHIVE"
78
Stefan Reinauer699ac272015-06-05 12:43:28 -070079# GCC toolchain directories
Stefan Reinauer074d9132009-09-26 16:43:17 +000080GMP_DIR="gmp-${GMP_VERSION}"
81MPFR_DIR="mpfr-${MPFR_VERSION}"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000082MPC_DIR="mpc-${MPC_VERSION}"
83LIBELF_DIR="libelf-${LIBELF_VERSION}"
Stefan Reinauer074d9132009-09-26 16:43:17 +000084GCC_DIR="gcc-${GCC_VERSION}"
85BINUTILS_DIR="binutils-${BINUTILS_VERSION}"
86GDB_DIR="gdb-${GDB_VERSION}"
Patrick Georgi85bb9462016-02-11 17:22:16 +010087IASL_DIR="acpica-unix2-${IASL_VERSION}"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010088PYTHON_DIR="Python-${PYTHON_VERSION}"
89EXPAT_DIR="expat-${EXPAT_VERSION}"
Stefan Reinauer14ce2132015-06-05 13:01:13 -070090# CLANG toolchain directories
91LLVM_DIR="llvm-${CLANG_VERSION}.src"
92CFE_DIR="cfe-${CLANG_VERSION}.src"
93CRT_DIR="compiler-rt-${CLANG_VERSION}.src"
94CTE_DIR="clang-tools-extra-${CLANG_VERSION}.src"
Stefan Reinauera851bbb2016-01-29 18:03:26 -080095MAKE_DIR="make-${MAKE_VERSION}"
Stefan Reinauer074d9132009-09-26 16:43:17 +000096
Patrick Georgi6321f522015-02-27 23:36:26 +010097unset MAKELEVEL MAKEFLAGS
98
Patrick Georgi1861ff72011-10-31 12:15:55 +010099red='\033[0;31m'
100RED='\033[1;31m'
101green='\033[0;32m'
102GREEN='\033[1;32m'
103blue='\033[0;34m'
104BLUE='\033[1;34m'
105cyan='\033[0;36m'
106CYAN='\033[1;36m'
107NC='\033[0m' # No Color
Stefan Reinauer074d9132009-09-26 16:43:17 +0000108
zbaoe05c1ea2015-08-05 23:10:05 -0400109UNAME=$(uname | grep -iq cygwin && echo Cygwin || uname)
Martin Roth88463822016-01-07 11:03:36 -0700110HALT_FOR_TOOLS=0
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700111
Patrick Georgi198d23c2012-12-08 08:02:44 +0100112normalize_dirs()
113{
114 mkdir -p $DESTDIR$TARGETDIR/lib
115 test -d $DESTDIR$TARGETDIR/lib32 && mv $DESTDIR$TARGETDIR/lib32/* $DESTDIR$TARGETDIR/lib
116 test -d $DESTDIR$TARGETDIR/lib64 && mv $DESTDIR$TARGETDIR/lib64/* $DESTDIR$TARGETDIR/lib
117 rmdir -p $DESTDIR$TARGETDIR/lib32 $DESTDIR$TARGETDIR/lib64
118
119 perl -pi -e "s,/lib32,/lib," $DESTDIR$TARGETDIR/lib/*.la
120 perl -pi -e "s,/lib64,/lib," $DESTDIR$TARGETDIR/lib/*.la
121}
122
Stefan Reinauer93a96302015-06-15 12:36:53 -0700123please_install()
124{
Martin Roth88463822016-01-07 11:03:36 -0700125 HALT_FOR_TOOLS=1
Patrick Georgi5da95dc2015-07-17 23:33:05 +0200126 test -r /etc/os-release && . /etc/os-release
Stefan Reinauer93a96302015-06-15 12:36:53 -0700127 case "$ID_LIKE" in
128 debian) solution="sudo apt-get install $1" ;;
129 suse) solution="sudo zypper install $1" ;;
130 *) solution="using your OS packaging system" ;;
131 esac
132
Patrick Georgidf1ff232017-01-07 09:28:43 +0100133 printf "${RED}ERROR:${red} Missing tool: Please install '$1'. (eg $solution)${NC}\n" >&2
Martin Rothe3963172016-01-06 13:54:32 -0700134 if [ -n "$2" ]; then
Patrick Georgidf1ff232017-01-07 09:28:43 +0100135 printf "${RED}ERROR:${red} or install '$2'.${NC}\n" >&2
Martin Rothe3963172016-01-06 13:54:32 -0700136 fi
Stefan Reinauer93a96302015-06-15 12:36:53 -0700137}
138
Patrick Georgib7062882015-02-24 10:52:14 +0100139searchtool()
Stefan Reinauer074d9132009-09-26 16:43:17 +0000140{
141 # $1 short name
Patrick Georgib7062882015-02-24 10:52:14 +0100142 # $2 search string
143 # $3 soft fail if set
Martin Rothe3963172016-01-06 13:54:32 -0700144 # $4 alternative package to install on failure
Patrick Georgib7062882015-02-24 10:52:14 +0100145 # result: file name of that tool on stdout
146 # or no output if nothing suitable was found
147 search=GNU
148 if [ -n "$2" ]; then
149 search="$2"
150 fi
Stefan Reinauer074d9132009-09-26 16:43:17 +0000151 for i in "$1" "g$1" "gnu$1"; do
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700152 if [ -x "$(which $i 2>/dev/null)" ]; then
153 if [ "$(cat /dev/null | $i --version 2>&1 | grep -c "$search")" \
154 -gt 0 ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000155 echo $i
156 return
157 fi
158 fi
159 done
Andrew Wub67e9a12014-04-28 18:13:44 +0800160 # A workaround for OSX 10.9 and some BSDs, whose nongnu
161 # patch and tar also work.
Patrick Georgi7cb26b42015-04-28 21:29:22 +0200162 if [ $UNAME = "Darwin" -o $UNAME = "FreeBSD" -o $UNAME = "NetBSD" -o $UNAME = "OpenBSD" ]; then
Patrick Georgib7062882015-02-24 10:52:14 +0100163 if [ "$1" = "patch" -o "$1" = "tar" ]; then
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700164 if [ -x "$(which $1 2>/dev/null)" ]; then
Zheng Bao36156ff2012-09-28 16:18:58 +0800165 echo $1
166 return
167 fi
168 fi
169 fi
zbao5cf758d2015-09-01 22:28:57 -0400170 if echo $1 | grep -q "sum" ; then
171 algor=$(echo $1 | sed -e 's,sum,,')
172 if [ -x "$(which $1 2>/dev/null)" ]; then
173 #xxxsum [file]
174 echo $1
175 return
176 elif [ -x "$(which $algor 2>/dev/null)" ]; then
177 #xxx [file]
178 echo $algor
179 return
180 elif [ -x "$(which openssl 2>/dev/null)" ]; then
181 #openssl xxx [file]
182 echo openssl $algor
183 return
184 elif [ -x "$(which cksum 2>/dev/null)" ]; then
185 #cksum -a xxx [file]
186 #cksum has special options in NetBSD. Actually, NetBSD will use the second case above.
187 echo "buildgcc" | cksum -a $algor > /dev/null 2>/dev/null && \
188 echo cksum -a $algor
189 return
zbao939dc842015-04-30 04:44:07 +0800190 fi
191 fi
Martin Rothe3963172016-01-06 13:54:32 -0700192
Martin Roth88463822016-01-07 11:03:36 -0700193 [ -z "$3" ] && please_install $1 $4
Patrick Georgib7062882015-02-24 10:52:14 +0100194 false
Stefan Reinauer074d9132009-09-26 16:43:17 +0000195}
196
Martin Roth591790f2016-03-20 20:39:04 -0600197# Run a compile check of the specified library option to see if it's installed
198check_for_library() {
199 local LIBRARY_FLAGS=$1
Aaron Durbin0ac4e5a2016-04-07 16:56:25 -0500200 local LIBRARY_PACKAGES="$2"
Martin Roth591790f2016-03-20 20:39:04 -0600201 local LIBTEST_FILE=.libtest
202
203 echo "int main(int argc, char **argv) { (void) argc; (void) argv; return 0; }" > "${LIBTEST_FILE}.c"
204
205 cc $CFLAGS $LIBRARY_FLAGS "${LIBTEST_FILE}.c" -o "${LIBTEST_FILE}" >/dev/null 2>&1 || \
206 please_install "$LIBRARY_PACKAGES"
207 rm -rf "${LIBTEST_FILE}.c" "${LIBTEST_FILE}"
208}
209
Nico Huberaee7f462016-09-20 12:55:19 +0200210buildcc_major() {
211 echo "${GCC_VERSION}" | cut -d. -f1
212}
213
Nico Huber26267a72016-12-04 02:45:58 +0100214buildcc_minor() {
215 echo "${GCC_VERSION}" | cut -d. -f2
216}
217
Nico Huberaee7f462016-09-20 12:55:19 +0200218buildcc_version() {
219 echo "${GCC_VERSION}" | cut -d. -f1-2
220}
221
222hostcc_major() {
223 (echo __GNUC__ | ${CC} -E - 2>/dev/null || echo 0) | tail -1
224}
225
226hostcc_minor() {
227 (echo __GNUC_MINOR__ | ${CC} -E - 2>/dev/null || echo 0) | tail -1
228}
229
230hostcc_version() {
231 printf "%d.%d" "$(hostcc_major)" "$(hostcc_minor)"
232}
233
Nico Huber75797162016-09-20 13:01:57 +0200234hostcc_has_gnat1() {
235 [ -x "$(${CC} -print-prog-name=gnat1)" ]
236}
237
238ada_requested() {
239 echo "${LANGUAGES}" | grep -q '\<ada\>'
240}
241
242check_gnat() {
243 if hostcc_has_gnat1; then
Nico Huber26267a72016-12-04 02:45:58 +0100244 if [ \( "$(hostcc_major)" -lt "$(buildcc_major)" -o \
245 \( "$(hostcc_major)" -eq "$(buildcc_major)" -a \
246 "$(hostcc_minor)" -lt "$(buildcc_minor)" \) \) \
247 -a \
248 "${BOOTSTRAP}" != "1" ]; \
249 then
Nico Huber75797162016-09-20 13:01:57 +0200250 printf "\n${RED}ERROR:${red} Building the Ada compiler (gnat $(buildcc_version)) "
Nico Huber26267a72016-12-04 02:45:58 +0100251 printf "with an older host compiler\n version ($(hostcc_version)) "
Nico Huber75797162016-09-20 13:01:57 +0200252 printf "requires bootstrapping (-b).${NC}\n\n"
253 HALT_FOR_TOOLS=1
254 fi
Nico Huber04a1f6a2016-09-20 13:07:49 +0200255 else
256 please_install gnat
Nico Huber75797162016-09-20 13:01:57 +0200257 fi
258}
259
Nico Huber156d87c2016-09-20 12:59:53 +0200260check_cc() {
261 if is_package_enabled "GCC"; then
262 if [ "$(hostcc_major)" != "$(buildcc_major)" -a "${BOOTSTRAP}" != "1" ]; then
263 printf "\n${red}warning: Building GCC $(buildcc_version) with a different major "
264 printf "version ($(hostcc_version)).\n"
265 printf " Bootstrapping (-b) is recommended.${NC}\n\n"
266 fi
Nico Huber75797162016-09-20 13:01:57 +0200267 if ada_requested; then
268 check_gnat
269 fi
Nico Huber156d87c2016-09-20 12:59:53 +0200270 fi
271}
272
zbao06e85ac2015-08-24 22:08:36 -0400273check_sum() {
274 test -z "$CHECKSUM" || \
275 test "$(cat sum/$1.cksum 2>/dev/null | sed -e 's@.*\([0-9a-f]\{40,\}\).*@\1@')" = \
276 "$($CHECKSUM tarballs/$1 2>/dev/null | sed -e 's@.*\([0-9a-f]\{40,\}\).*@\1@')"
277}
278
279compute_sum() {
280 test ! -f sum/$1.cksum && test -f tarballs/$1 && \
281 (test -z "$CHECKSUM" || $CHECKSUM tarballs/$1 > sum/$1.cksum ) && \
282 printf "(checksum created. ${RED}Note. Please upload sum/$1.cksum if the corresponding archive is upgraded.)${NC}"
283}
284
Stefan Reinauer88935482015-06-05 09:51:10 -0700285download() {
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700286 package=$1
287 archive="$(eval echo \$$package"_ARCHIVE")"
Stefan Reinauer699ac272015-06-05 12:43:28 -0700288
Stefan Reinauerd7649122015-06-09 11:44:25 -0700289 FILE=$(basename $archive)
Stefan Reinauer88935482015-06-05 09:51:10 -0700290 printf " * $FILE "
291
zbaod22b9ea2015-08-30 23:35:16 -0400292 if test -f tarballs/$FILE && check_sum $FILE ; then
Patrick Georgidf1ff232017-01-07 09:28:43 +0100293 echo "(cached)"
zbaod22b9ea2015-08-30 23:35:16 -0400294 else
Paul Menzelb2ba3952015-06-12 11:58:14 +0200295 printf "(downloading from $archive)"
Stefan Reinauer88935482015-06-05 09:51:10 -0700296 rm -f tarballs/$FILE
297 cd tarballs
zbao282dd952015-09-06 05:00:04 -0400298 download_showing_percentage $archive
Stefan Reinauer88935482015-06-05 09:51:10 -0700299 cd ..
zbao06e85ac2015-08-24 22:08:36 -0400300 compute_sum $FILE
zbaod22b9ea2015-08-30 23:35:16 -0400301 fi
302
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700303 if [ ! -f tarballs/$FILE ]; then
Patrick Georgidf1ff232017-01-07 09:28:43 +0100304 printf "${RED}Failed to download $FILE.${NC}\n"
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700305 exit 1
306 fi
Stefan Reinauer88935482015-06-05 09:51:10 -0700307}
308
309unpack_and_patch() {
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700310 package=$1
311 archive="$(eval echo \$$package"_ARCHIVE")"
312 dir="$(eval echo \$$package"_DIR")"
Stefan Reinauer88935482015-06-05 09:51:10 -0700313 test -d ${dir} && test -f ${dir}/.unpack_success || (
Stefan Reinauerd7649122015-06-09 11:44:25 -0700314 printf " * $(basename $archive)\n"
Stefan Reinauer88935482015-06-05 09:51:10 -0700315 FLAGS=zxf
Stefan Reinauerd7649122015-06-09 11:44:25 -0700316 suffix=$(echo $archive | sed 's,.*\.,,')
Martin Roth95f7b222016-03-20 12:38:48 -0600317 if [ "$suffix" = "gz" ] && [ -n "$PIGZ" ]; then FLAGS="-I pigz -xf"
318 elif [ "$suffix" = "gz" ]; then FLAGS=zxf
319 elif [ "$suffix" = "bz2" ] && [ -n "$LBZIP2" ]; then FLAGS="-I lbzip2 -xf"
320 elif [ "$suffix" = "bz2" ]; then FLAGS=jxf
321 elif [ "$suffix" = "xz" ]; then FLAGS="--xz -xf"
322 elif [ "$suffix" = "lzma" ]; then FLAGS="--lzma -xf"
323 fi
Stefan Reinauerd7649122015-06-09 11:44:25 -0700324 $TAR $FLAGS tarballs/$(basename $archive)
Stefan Reinauer88935482015-06-05 09:51:10 -0700325 for patch in patches/${dir}_*.patch; do
326 test -r $patch || continue
Stefan Reinauerd7649122015-06-09 11:44:25 -0700327 printf " o $(basename $patch)\n"
Nico Huber4b48ed82016-07-27 00:28:03 +0200328 (cd ${dir} && $PATCH -s -N -p1 <../${patch}) || {
Stefan Reinauer88935482015-06-05 09:51:10 -0700329 printf "\n${RED}Failed $patch.${NC}\n"
Stefan Reinauer916b8452015-06-09 11:54:49 -0700330 exit 1
331 }
Stefan Reinauer88935482015-06-05 09:51:10 -0700332 done
333 touch ${dir}/.unpack_success
334 )
335}
336
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700337fn_exists()
338{
Patrick Georgic8665912015-06-11 21:04:31 +0200339 type $1 >/dev/null 2>&1
Patrick Georgi74c06422015-03-25 18:40:13 +0100340}
341
Patrick Georgif2c15f52015-06-11 21:07:31 +0200342is_package_enabled()
343{
344 echo "$PACKAGES" |grep -q "\<$1\>"
345}
346
Martin Roth444ece22016-04-01 18:46:29 -0600347package_uses_targetarch()
348{
Stefan Reinauera344b682016-04-21 19:29:51 -0700349 if [ "$1" = "GCC" ] || [ "$1" = "GDB" ] || [ "$1" = "BINUTILS" ]; then
Martin Roth444ece22016-04-01 18:46:29 -0600350 true
351 else
352 false
353 fi
354}
355
Nico Huber11ea2b32016-01-26 16:09:31 +0100356generic_build()
357{
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700358 package=$1
Nico Huber11ea2b32016-01-26 16:09:31 +0100359 host_target=$2
360 builddir=$3
361 success=$4
Martin Rothc295d5e2016-11-14 11:56:11 -0700362 version=$5
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700363
364 fn_exists build_$package || return
365
Nico Huber11ea2b32016-01-26 16:09:31 +0100366 mkdir -p "$builddir"
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700367
Nico Huber11ea2b32016-01-26 16:09:31 +0100368 if [ -f "$success" ]; then
Martin Roth2c6a8062016-11-14 11:58:39 -0700369 printf "Skipping $package v$version for $host_target as it is already built\n"
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700370 else
Martin Roth2c6a8062016-11-14 11:58:39 -0700371 printf "Building $package v$version for $host_target ... "
Nico Huber11ea2b32016-01-26 16:09:31 +0100372 DIR="$PWD"
373 cd "$builddir"
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700374 rm -f .failed
Nico Huber11ea2b32016-01-26 16:09:31 +0100375 build_${package} $host_target > build.log 2>&1
376 cd "$DIR"
377 if [ ! -f "$builddir/.failed" ]; then
378 touch "$success";
379 else
380 printf "${RED}failed${NC}. Check $builddir/build.log.\n"
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700381 exit 1
382 fi
383 printf "${green}ok${NC}\n"
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700384 fi
385}
386
Nico Huber11ea2b32016-01-26 16:09:31 +0100387build_for_host()
388{
Martin Rothc295d5e2016-11-14 11:56:11 -0700389 package="$1"
390 version="$(eval echo \$$package"_VERSION")"
Patrick Georgi1b593e52016-11-25 15:27:41 +0100391 generic_build "$package" host "build-$package" "${DESTDIR}${TARGETDIR}/.${package}.${version}.success" "$version"
Nico Huber11ea2b32016-01-26 16:09:31 +0100392}
393
394build_for_target()
395{
Martin Rothc295d5e2016-11-14 11:56:11 -0700396 package="$1"
397 version="$(eval echo \$$package"_VERSION")"
Patrick Georgi1b593e52016-11-25 15:27:41 +0100398 generic_build "$package" target "build-${TARGETARCH}-$package" "${DESTDIR}${TARGETDIR}/.${TARGETARCH}-${package}.${version}.success" "$version"
Nico Huber11ea2b32016-01-26 16:09:31 +0100399}
400
401build()
402{
403 if package_uses_targetarch $1; then
Patrick Georgi1b593e52016-11-25 15:27:41 +0100404 if [ $BOOTSTRAP -eq 1 -a ! -f "${DESTDIR}${TARGETDIR}/.GCC.success" ]; then
Nico Huber234d2462016-01-26 16:10:17 +0100405 build_for_host GCC
406 fi
Nico Huber11ea2b32016-01-26 16:09:31 +0100407 build_for_target $1
408 else
409 build_for_host $1
410 fi
411}
412
Zheng Baobb003c82016-08-05 13:41:51 +0800413quit()
414{
415 printf "${NC}Stop\n"
416 exit 1
417}
418
Stefan Reinauer074d9132009-09-26 16:43:17 +0000419cleanup()
420{
Stefan Reinauer88e83e52016-04-06 15:39:48 -0700421 if [ $SAVETEMPS -ne 0 ]; then
422 printf "Leaving temporary files around... ${green}ok${NC}\n"
423 return
424 fi
425
Stefan Reinauer074d9132009-09-26 16:43:17 +0000426 printf "Cleaning up temporary files... "
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700427 for package in $PACKAGES; do
Martin Roth444ece22016-04-01 18:46:29 -0600428 rm -rf build-${TARGETARCH}-$package build-$package $(eval echo \$$package"_DIR")
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700429 done
zbaoff3f15c2015-08-26 22:00:31 -0400430 rm -f getopt
Stefan Reinauer074d9132009-09-26 16:43:17 +0000431 printf "${green}ok${NC}\n"
432}
433
434myhelp()
435{
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700436 printf "Usage: $0 [-V] [-c] [-p <platform>] [-d <target directory>] [-D <dest dir>] [-C] [-G] [-S]\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000437 printf " $0 [-V|--version]\n"
438 printf " $0 [-h|--help]\n\n"
439
440 printf "Options:\n"
441 printf " [-V|--version] print version number and exit\n"
442 printf " [-h|--help] print this help and exit\n"
443 printf " [-c|--clean] remove temporary files before build\n"
444 printf " [-t|--savetemps] don't remove temporary files after build\n"
Patrick Georgic1a75b12011-11-04 21:37:14 +0100445 printf " [-y|--ccache] Use ccache when building cross compiler\n"
Nico Huber152e78e2016-09-20 15:38:40 +0200446 printf " [-n|--nocolor] don't print color codes in output\n"
447 printf " [-u|--urls] print the urls for all packages\n"
Patrick Georgi73166c72010-04-14 20:42:42 +0000448 printf " [-j|--jobs <num>] run <num> jobs in parallel in make\n"
Martin Roth588c79d2016-03-20 12:03:20 -0600449 printf " [-s]--supported <tool> print supported version of a tool\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000450 printf " [-d|--directory <target dir>] target directory to install cross compiler to\n"
Martin Roth588c79d2016-03-20 12:03:20 -0600451 printf " (defaults to $TARGETDIR)\n\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000452 printf " [-D|--destdir <dest dir>] destination directory to install cross compiler to\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100453 printf " (for RPM builds, default unset)\n"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700454 printf " [-P|--package <package>] Build a specific package: GCC, CLANG, IASL, GDB\n"
455 printf " (defaults to $PACKAGE)\n"
456 printf "GCC specific options:\n"
Nico Huber234d2462016-01-26 16:10:17 +0100457 printf " [-b|--bootstrap] bootstrap the host compiler before building\n"
458 printf " the cross compiler\n"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700459 printf " [-p|--platform <platform>] target platform to build cross compiler for\n"
460 printf " (defaults to $TARGETARCH)\n"
Nico Huberbb313bf2015-09-08 12:30:27 +0200461 printf " [-l|--languages <languages>] comma separated list of target languages\n"
Nico Huber66c2c1a2016-09-20 13:09:29 +0200462 printf " (defaults to $DEFAULT_LANGUAGES)\n"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700463 printf "GDB specific options:\n"
464 printf " [-p|--platform <platform>] target platform to build cross compiler for\n"
465 printf " (defaults to $TARGETARCH)\n"
466 printf " [-S|--scripting] build scripting support for GDB\n\n"
Martin Rothd1da74f2015-06-21 12:06:28 -0600467 printf "Platforms for GCC & GDB:\n"
Martin Roth3e0f74d2016-03-08 12:07:04 -0700468 printf " x86_64 i386-elf i386-mingw32 mipsel-elf riscv-elf arm aarch64\n"
Jonathan Neuschäferf14f6402016-03-11 20:22:23 +0100469 printf " powerpc64le-linux-gnu nds32le-elf\n\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000470}
471
Martin Rothedf965a2015-11-25 16:58:33 -0700472printversion() {
473 printf "${blue}Welcome to the ${red}coreboot${blue} cross toolchain builder v$CROSSGCC_VERSION ($CROSSGCC_DATE)${NC}\n\n"
474}
475
Stefan Reinauer074d9132009-09-26 16:43:17 +0000476myversion()
477{
Martin Rothedf965a2015-11-25 16:58:33 -0700478 printversion
Stefan Reinauer074d9132009-09-26 16:43:17 +0000479
480 cat << EOF
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000481Copyright (C) 2008-2010 by coresystems GmbH
Marc Jones2aac3f62011-08-08 16:07:50 -0600482Copyright (C) 2011 by Sage Electronic Engineering
Stefan Reinauer074d9132009-09-26 16:43:17 +0000483
484This program is free software; you can redistribute it and/or modify
485it under the terms of the GNU General Public License as published by
486the Free Software Foundation; version 2 of the License.
487
488This program is distributed in the hope that it will be useful,
489but WITHOUT ANY WARRANTY; without even the implied warranty of
490MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
491GNU General Public License for more details.
492
493EOF
494}
495
Nico Huber5f72f962016-01-31 23:05:19 +0100496have_hostcflags_from_gmp() {
497 grep -q __GMP_CFLAGS $DESTDIR$TARGETDIR/include/gmp.h >/dev/null 2>&1
498}
499
500set_hostcflags_from_gmp() {
501 # Now set CFLAGS to match GMP CFLAGS but strip out -pedantic
502 # as GCC 4.6.x fails if it's there.
Idwer Volleringba349ab2016-07-24 02:10:19 +0200503 export HOSTCFLAGS="$(grep __GMP_CFLAGS $DESTDIR$TARGETDIR/include/gmp.h |cut -d\" -f2 |\
504 sed s,-pedantic,,)"
Nico Huber5f72f962016-01-31 23:05:19 +0100505}
506
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700507build_GMP() {
Nico Huber8bbd5962016-12-22 16:05:54 +0100508 # Check if GCC enables `-pie` by default (possible since GCC 6).
509 # We need PIC in all static libraries then.
Nico Huber2c1c02e2017-01-02 20:51:28 +0100510 if $CC -dumpspecs 2>/dev/null | grep -q '[{;][[:space:]]*:-pie\>'
Nico Huber8bbd5962016-12-22 16:05:54 +0100511 then
512 OPTIONS="$OPTIONS --with-pic"
513 fi
514
Paul Kocialkowski7899db22016-06-17 21:41:00 -0700515 CC="$CC" ../${GMP_DIR}/configure --disable-shared --enable-fat \
Nico Huber5f72f962016-01-31 23:05:19 +0100516 --prefix=$TARGETDIR $OPTIONS \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700517 || touch .failed
518 $MAKE $JOBS || touch .failed
519 $MAKE install DESTDIR=$DESTDIR || touch .failed
520
521 normalize_dirs
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700522
Nico Huber5f72f962016-01-31 23:05:19 +0100523 set_hostcflags_from_gmp
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700524}
525
526build_MPFR() {
527 test $UNAME = "Darwin" && CFLAGS="$CFLAGS -force_cpusubtype_ALL"
528 CC="$CC" ../${MPFR_DIR}/configure --disable-shared --prefix=$TARGETDIR \
529 --infodir=$TARGETDIR/info \
530 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
531 touch .failed
532 $MAKE $JOBS || touch .failed
533 $MAKE install DESTDIR=$DESTDIR || touch .failed
534
535 normalize_dirs
536
537 # work around build problem of libgmp.la
538 if [ "$DESTDIR" != "" ]; then
539 perl -pi -e "s,$DESTDIR,," $DESTDIR$TARGETDIR/libgmp.la
540 fi
541}
542
543build_MPC() {
544 CC="$CC" ../${MPC_DIR}/configure --disable-shared --prefix=$TARGETDIR \
545 --infodir=$TARGETDIR/info --with-mpfr=$DESTDIR$TARGETDIR \
546 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
547 touch .failed
548 $MAKE $JOBS || touch .failed
549 $MAKE install DESTDIR=$DESTDIR || touch .failed
550
551 normalize_dirs
552}
553
554build_LIBELF() {
555 CC="$CC" CFLAGS="$HOSTCFLAGS" libelf_cv_elf_h_works=no \
556 ../${LIBELF_DIR}/configure --disable-shared --prefix=$TARGETDIR \
557 --infodir=$TARGETDIR/info CFLAGS="$HOSTCFLAGS" || touch .failed
558 $MAKE $JOBS || touch .failed
559 $MAKE install prefix=$DESTDIR$TARGETDIR || touch .failed
560
561 normalize_dirs
562}
563
564build_BINUTILS() {
Nico Huberae6187f2016-12-22 22:16:39 +0100565 if [ $TARGETARCH = "x86_64-elf" ]; then
Stefan Reinauer682a90c2015-06-09 14:59:58 -0700566 ADDITIONALTARGET=",i386-elf"
567 fi
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700568 CC="$CC" ../binutils-${BINUTILS_VERSION}/configure --prefix=$TARGETDIR \
Stefan Reinauer682a90c2015-06-09 14:59:58 -0700569 --target=${TARGETARCH} --enable-targets=${TARGETARCH}${ADDITIONALTARGET} \
570 --disable-werror --disable-nls --enable-lto --enable-gold \
Stefan Reinauer2fe2d3d2016-04-05 02:14:48 -0700571 --enable-interwork --enable-multilib \
Nico Huber010ecf802016-12-22 16:19:37 +0100572 --enable-plugins --enable-multilibs
573 CFLAGS="$HOSTCFLAGS" \
574 CXXFLAGS="$HOSTCFLAGS" \
575 || touch .failed
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700576 $MAKE $JOBS || touch .failed
577 $MAKE install DESTDIR=$DESTDIR || touch .failed
578}
579
Nico Huber234d2462016-01-26 16:10:17 +0100580bootstrap_GCC() {
581 CC="$CC" \
582 CFLAGS="$HOSTCFLAGS" \
583 CFLAGS_FOR_BUILD="$HOSTCFLAGS" \
584 CFLAGS_FOR_TARGET="$HOSTCFLAGS -fPIC" \
585 CXXFLAGS="$HOSTCFLAGS" \
586 CXXFLAGS_FOR_BUILD="$HOSTCFLAGS" \
587 CXXFLAGS_FOR_TARGET="$HOSTCFLAGS -fPIC" \
588 ../gcc-${GCC_VERSION}/configure \
589 --prefix=$TARGETDIR --libexecdir=$TARGETDIR/lib \
590 --enable-bootstrap \
591 --disable-werror --disable-nls \
592 --disable-shared --disable-multilib \
593 --disable-libssp --disable-libquadmath --disable-libcc1 \
594 ${GCC_OPTIONS} --enable-languages="${LANGUAGES}" \
595 --with-gmp=$DESTDIR$TARGETDIR --with-mpfr=$DESTDIR$TARGETDIR \
596 --with-mpc=$DESTDIR$TARGETDIR --with-libelf=$DESTDIR$TARGETDIR \
597 --with-pkgversion="coreboot bootstrap v$CROSSGCC_VERSION $CROSSGCC_DATE" \
598 && \
599 $MAKE $JOBS BOOT_CFLAGS="$HOSTCFLAGS" BUILD_CONFIG="" bootstrap && \
600 $MAKE install-gcc \
601 install-target-libgcc \
602 maybe-install-target-libada \
603 maybe-install-target-libstdc++-v3 \
604 DESTDIR=$DESTDIR && \
605 ln -s gcc $DESTDIR$TARGETDIR/bin/cc || touch .failed
606}
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700607
Nico Huber234d2462016-01-26 16:10:17 +0100608build_cross_GCC() {
Stefan Reinauer45f77b82016-04-03 20:52:01 -0700609 # Work around crazy code generator in GCC that confuses CLANG.
Aaron Durbinb2229dc2016-04-07 16:58:10 -0500610 $CC --version | grep clang >/dev/null 2>&1 && \
Stefan Reinauer45f77b82016-04-03 20:52:01 -0700611 HOSTCFLAGS="$HOSTCFLAGS -fbracket-depth=1024"
612
Stefan Reinauerd0f83722015-06-09 11:52:28 -0700613 # GCC does not honor HOSTCFLAGS at all. CFLAGS are used for
614 # both target and host object files.
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700615 # There's a work-around called CFLAGS_FOR_BUILD and CFLAGS_FOR_TARGET
616 # but it does not seem to work properly. At least the host library
617 # libiberty is not compiled with CFLAGS_FOR_BUILD.
Stefan Reinauer45f77b82016-04-03 20:52:01 -0700618 # Also set the CXX version of the flags because GCC is now compiled
619 # using C++.
Patrick Georgi0a97d7e2016-01-25 09:51:22 +0100620 CC="$CC" CFLAGS_FOR_TARGET="-O2 -Dinhibit_libc" CFLAGS="$HOSTCFLAGS" \
Stefan Reinauer45f77b82016-04-03 20:52:01 -0700621 CFLAGS_FOR_BUILD="$HOSTCFLAGS" CXXFLAGS="$HOSTCFLAGS" \
622 CXXFLAGS_FOR_BUILD="$HOSTCFLAGS" ../gcc-${GCC_VERSION}/configure \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700623 --prefix=$TARGETDIR --libexecdir=$TARGETDIR/lib \
624 --target=${TARGETARCH} --disable-werror --disable-shared \
Stefan Reinauer2f97ebc2015-06-09 12:24:54 -0700625 --enable-lto --enable-plugins --enable-gold --enable-ld=default \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700626 --disable-libssp --disable-bootstrap --disable-nls \
627 --disable-libquadmath --without-headers \
Patrick Georgi0a97d7e2016-01-25 09:51:22 +0100628 --disable-threads \
Patrick Georgi1fc02d12016-03-23 21:44:43 +0100629 --enable-interwork --enable-multilib --enable-targets=all \
Patrick Georgi0a97d7e2016-01-25 09:51:22 +0100630 --disable-libatomic --disable-libcc1 --disable-decimal-float \
Nico Huberbb313bf2015-09-08 12:30:27 +0200631 ${GCC_OPTIONS} --enable-languages="${LANGUAGES}" \
Ronald G. Minnich7ee16b72016-02-12 21:54:59 +0000632 --with-system-zlib \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700633 --with-gmp=$DESTDIR$TARGETDIR --with-mpfr=$DESTDIR$TARGETDIR \
634 --with-mpc=$DESTDIR$TARGETDIR --with-libelf=$DESTDIR$TARGETDIR \
635 --with-pkgversion="coreboot toolchain v$CROSSGCC_VERSION $CROSSGCC_DATE" \
636 || touch .failed
637 $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-gcc || touch .failed
638 $MAKE install-gcc DESTDIR=$DESTDIR || touch .failed
639
Stefan Reinauerd7649122015-06-09 11:44:25 -0700640 if [ "$(echo $TARGETARCH | grep -c -- -mingw32)" -eq 0 ]; then
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700641 $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-target-libgcc || touch .failed
642 $MAKE install-target-libgcc DESTDIR=$DESTDIR || touch .failed
643 fi
644}
645
Nico Huber234d2462016-01-26 16:10:17 +0100646build_GCC() {
647 if [ "$1" = host ]; then
648 bootstrap_GCC
649 else
650 build_cross_GCC
651 fi
652}
653
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700654build_EXPAT() {
655 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${EXPAT_DIR}/configure --disable-shared \
Stefan Reinauera344b682016-04-21 19:29:51 -0700656 --prefix=$TARGETDIR || touch .failed
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700657 $MAKE || touch .failed
658 $MAKE install DESTDIR=$DESTDIR || touch .failed
659
660 normalize_dirs
661}
662
663build_PYTHON() {
664 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${PYTHON_DIR}/configure --prefix=$TARGETDIR \
Stefan Reinauera344b682016-04-21 19:29:51 -0700665 || touch .failed
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700666 $MAKE $JOBS || touch .failed
667 $MAKE install DESTDIR=$DESTDIR || touch .failed
668
669 normalize_dirs
670}
671
672build_GDB() {
673 export PYTHONHOME=$DESTDIR$TARGETDIR
674 if [ $(uname) != "FreeBSD" -a $(uname) != "NetBSD" ]; then
675 LIBDL="-ldl"
676 fi
677 LDFLAGS="-Wl,-rpath,\$\$ORIGIN/../lib/ -L$DESTDIR$TARGETDIR/lib \
678 -lpthread $LIBDL -lutil" \
679 CC="$CC" CFLAGS="$HOSTCFLAGS -I$DESTDIR$TARGETDIR/include" \
Stefan Reinauer7b40e422015-06-09 11:56:32 -0700680 ../${GDB_DIR}/configure --prefix=$TARGETDIR \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700681 --target=${TARGETARCH} --disable-werror --disable-nls
682 $MAKE $JOBS || touch .failed
683 $MAKE install DESTDIR=$DESTDIR || touch .failed
684}
685
686build_IASL() {
687 RDIR=$PWD
688 cd ../$IASL_DIR/generate/unix
689 CFLAGS="$HOSTCFLAGS"
690 HOST="_LINUX"
691 test $UNAME = "Darwin" && HOST="_APPLE"
692 test $UNAME = "FreeBSD" && HOST="_FreeBSD"
693 test $UNAME = "Cygwin" && HOST="_CYGWIN"
Martin Roth6f656132015-12-08 11:14:10 -0700694 HOST="$HOST" OPT_CFLAGS="-O -D_FORTIFY_SOURCE=2 -D COREBOOT_TOOLCHAIN_VERSION='\"coreboot toolchain v$CROSSGCC_VERSION $CROSSGCC_DATE\"' " CFLAGS="$CFLAGS" $MAKE CC="$CC" iasl || touch $RDIR/.failed
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700695 rm -f $DESTDIR$TARGETDIR/bin/iasl || touch $RDIR/.failed
696 cp bin/iasl $DESTDIR$TARGETDIR/bin || touch $RDIR/.failed
697}
698
699build_LLVM() {
700 cd ..
701 ln -sf $PWD/$CFE_DIR $LLVM_DIR/tools/clang
702 ln -sf $PWD/$CTE_DIR $LLVM_DIR/tools/clang/tools/extra
703 ln -sf $PWD/$CRT_DIR $LLVM_DIR/projects/compiler-rt
704 cd -
705
706 $CMAKE -G "Unix Makefiles" -DCMAKE_INSTALL_PREFIX=$DESTDIR$TARGETDIR \
Martin Rothfb5647a2015-12-18 09:26:45 -0700707 -DCLANG_VENDOR="coreboot toolchain v$CROSSGCC_VERSION $CROSSGCC_DATE - " \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700708 -DCMAKE_BUILD_TYPE=Release ../$LLVM_DIR || touch .failed
709 $MAKE $JOBS || touch .failed
710 $MAKE install || touch .failed
711
712 cp -a ../$CFE_DIR/tools/scan-build/* $DESTDIR$TARGETDIR/bin
713 cp -a ../$CFE_DIR/tools/scan-view/* $DESTDIR$TARGETDIR/bin
Stefan Reinauere9e6e3d2015-07-07 00:20:42 +0200714
715 # create symlinks to work around broken --print-librt-file-name
716 # when used with -target.
717 cd $DESTDIR$TARGETDIR/lib/clang/${CLANG_VERSION}/lib
718 for i in */libclang_rt.builtins*.a; do
719 ln -s $i .
720 done
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700721}
722
Stefan Reinauera851bbb2016-01-29 18:03:26 -0800723build_MAKE() {
724 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${MAKE_DIR}/configure --prefix=$TARGETDIR \
725 --disable-nls || touch .failed
726 $MAKE $JOBS || touch .failed
727 $MAKE install DESTDIR=$DESTDIR || touch .failed
728
729 normalize_dirs
730}
731
Martin Rothedf965a2015-11-25 16:58:33 -0700732print_stable() {
733 case "$PRINTSTABLE" in
734 AUTOCONF|autoconf) printf "%s\n" "$GCC_AUTOCONF_VERSION";;
735 BINUTILS|binutils) printf "%s\n" "$BINUTILS_VERSION";;
736 CLANG|clang) printf "%s\n" "$CLANG_VERSION";;
737 EXPAT|expat) printf "%s\n" "$EXPAT_VERSION";;
738 GCC|gcc) printf "%s\n" "$GCC_VERSION";;
739 GDB|gdb) printf "%s\n" "$GDB_VERSION";;
740 GMP|gmp) printf "%s\n" "$GMP_VERSION";;
741 IASL|iasl) printf "%s\n" "$IASL_VERSION";;
742 LIBELF|libelf) printf "%s\n" "$LIBELF_VERSION";;
743 MPC|mpc) printf "%s\n" "$MPC_VERSION";;
744 MPFR|mpfr) printf "%s\n" "$MPFR_VERSION";;
745 PYTHON|python) printf "%s\n" "$PYTHON_VERSION";;
Stefan Reinauera851bbb2016-01-29 18:03:26 -0800746 MAKE|make) printf "%s\n" "$MAKE_VERSION";;
Martin Rothedf965a2015-11-25 16:58:33 -0700747 *) printf "Unknown tool %s\n" "$PRINTSTABLE";;
748 esac
749}
Stefan Reinauer074d9132009-09-26 16:43:17 +0000750
Zheng Baobb003c82016-08-05 13:41:51 +0800751trap quit 1 2 3 15
752
Patrick Georgi6bba29f2010-01-29 17:40:52 +0000753# Look if we have getopt. If not, build it.
754export PATH=$PATH:.
755getopt - > /dev/null 2>/dev/null || gcc -o getopt getopt.c
756
Stefan Reinauer074d9132009-09-26 16:43:17 +0000757# parse parameters.. try to find out whether we're running GNU getopt
Stefan Reinauerd7649122015-06-09 11:44:25 -0700758getoptbrand="$(getopt -V | sed -e '1!d' -e 's,^\(......\).*,\1,')"
Peter Stuge09377b72011-08-21 06:24:55 +0200759if [ "${getoptbrand}" = "getopt" ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000760 # Detected GNU getopt that supports long options.
Nico Hubercc414dd2016-09-20 13:59:38 +0200761 args=$(getopt -l version,help,clean,directory:,bootstrap,platform:,languages:,package:,jobs:,destdir:,savetemps,scripting,ccache,supported:,urls,nocolor -o Vhcd:bp:l:P:j:D:tSys:un -- "$@")
Nico Huber78df0bf2016-09-20 14:11:53 +0200762 getopt_ret=$?
Nico Hubercc414dd2016-09-20 13:59:38 +0200763 eval set -- "$args"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000764else
765 # Detected non-GNU getopt
Nico Huber152e78e2016-09-20 15:38:40 +0200766 args=$(getopt Vhcd:bp:l:P:j:D:tSys:un $*)
Nico Huber78df0bf2016-09-20 14:11:53 +0200767 getopt_ret=$?
Stefan Reinauer074d9132009-09-26 16:43:17 +0000768 set -- $args
769fi
770
Nico Huber78df0bf2016-09-20 14:11:53 +0200771if [ $getopt_ret != 0 ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000772 myhelp
773 exit 1
774fi
775
776while true ; do
777 case "$1" in
778 -V|--version) shift; myversion; exit 0;;
779 -h|--help) shift; myhelp; exit 0;;
Patrick Georgi44af57a2013-12-19 22:06:22 +0100780 -c|--clean) shift; clean=1;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000781 -t|--savetemps) shift; SAVETEMPS=1;;
782 -d|--directory) shift; TARGETDIR="$1"; shift;;
Nico Huber234d2462016-01-26 16:10:17 +0100783 -b|--bootstrap) shift; BOOTSTRAP=1;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000784 -p|--platform) shift; TARGETARCH="$1"; shift;;
Nico Huberbb313bf2015-09-08 12:30:27 +0200785 -l|--languages) shift; LANGUAGES="$1"; shift;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000786 -D|--destdir) shift; DESTDIR="$1"; shift;;
Martin Roth2c6a8062016-11-14 11:58:39 -0700787 -j|--jobs) shift; THREADS="$1"; JOBS="-j $1"; shift;;
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700788 -P|--package) shift; PACKAGE="$1"; shift;;
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100789 -S|--scripting) shift; SKIPPYTHON=0;;
Patrick Georgic1a75b12011-11-04 21:37:14 +0100790 -y|--ccache) shift; USECCACHE=1;;
Martin Rothedf965a2015-11-25 16:58:33 -0700791 -s|--supported) shift; PRINTSTABLE="$1"; shift;;
Nico Huber152e78e2016-09-20 15:38:40 +0200792 -u|--urls) shift; printf "%s\n" "$ALL_ARCHIVES"; exit 0;;
793 -n|--nocolor) shift; \
Martin Roth4a53db02016-03-01 15:21:07 -0700794 unset red RED green GREEN blue BLUE cyan CYAN NC;;
Patrick Georgid2e0dd52013-06-09 08:05:45 +0200795 --) shift; break;;
Patrick Georgid2e0dd52013-06-09 08:05:45 +0200796 *) break;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000797 esac
798done
799
Nico Huberbd74d562016-09-20 14:16:43 +0200800if [ $# -gt 0 ]; then
801 printf "Excessive arguments: $*\n"
802 myhelp
803 exit 1
804fi
805
Martin Rothedf965a2015-11-25 16:58:33 -0700806if [ -n "$PRINTSTABLE" ]; then
807 print_stable
808 exit 0
809fi
810
811#print toolchain builder version string as the header
812printversion
813
Martin Roth2c6a8062016-11-14 11:58:39 -0700814printf "Building toolchain using %d thread(s).\n\n" "$THREADS"
815
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700816case "$TARGETARCH" in
Timothy Pearsona9f62352015-12-30 18:59:00 -0600817 x86_64-elf) ;;
818 x86_64*) TARGETARCH=x86_64-elf;;
819 i386-elf) ;;
820 i386-mingw32) ;;
821 mipsel-elf) ;;
Iru Caiae8e3a02016-04-02 10:50:59 +0800822 riscv-elf) TARGETARCH=riscv64-elf;;
Patrick Georgi0a97d7e2016-01-25 09:51:22 +0100823 powerpc64*-linux*) ;;
Timothy Pearsona9f62352015-12-30 18:59:00 -0600824 i386*) TARGETARCH=i386-elf;;
Stefan Reinauer27522ad2016-01-29 17:31:34 -0800825 arm*) TARGETARCH=arm-eabi;;
Timothy Pearsona9f62352015-12-30 18:59:00 -0600826 aarch64*) TARGETARCH=aarch64-elf;;
Martin Roth3e0f74d2016-03-08 12:07:04 -0700827 nds32le-elf) ;;
Timothy Pearsona9f62352015-12-30 18:59:00 -0600828 *) printf "${red}WARNING: Unsupported architecture $TARGETARCH.${NC}\n\n"; ;;
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700829esac
830
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700831# Figure out which packages to build
Stefan Reinauer699ac272015-06-05 12:43:28 -0700832
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700833case "$PACKAGE" in
834 GCC|gcc)
835 echo "Target architecture is now $TARGETARCH"
836 NAME="${TARGETARCH} cross GCC"
Stefan Reinauerbd8b2e32015-06-17 11:55:02 -0700837 PACKAGES="GMP MPFR MPC LIBELF BINUTILS GCC"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700838 ;;
839 GDB|gdb)
840 NAME="${TARGETARCH} cross GDB"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700841 if [ $SKIPPYTHON -eq 0 ]; then
Ronald G. Minnichfb944f42016-02-27 04:06:42 +0000842 PACKAGES="EXPAT PYTHON GDB"
843 else
844 PACKAGES="EXPAT GDB"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700845 fi
846 ;;
847 CLANG|clang)
848 NAME=clang
849 PACKAGES="LLVM CFE CRT CTE"
David Hendrickscd5cdd32015-06-15 17:03:22 -0700850 CMAKE=$(searchtool cmake "cmake") || exit $?
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700851 ;;
852 IASL|iasl)
853 NAME="IASL ACPI compiler"
854 PACKAGES=IASL
855 ;;
Stefan Reinauera851bbb2016-01-29 18:03:26 -0800856 MAKE|make)
857 NAME="GNU Make"
858 PACKAGES=MAKE
859 ;;
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700860 *)
Stefan Reinauera851bbb2016-01-29 18:03:26 -0800861 printf "${red}ERROR: Unsupported package $PACKAGE. (Supported packages are GCC, GDB, CLANG, IASL, MAKE)${NC}\n\n";
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700862 exit 1
863 ;;
864esac
Peter Stugeceacd772011-06-09 04:54:16 +0200865
Stefan Reinauer66e93352015-06-16 22:38:23 +0200866# Find all the required tools:
867
868TAR=$(searchtool tar) || exit $?
869PATCH=$(searchtool patch) || exit $?
870MAKE=$(searchtool make) || exit $?
871SHA1SUM=$(searchtool sha1sum)
zbao5cf758d2015-09-01 22:28:57 -0400872#SHA512SUM=$(searchtool sha512sum)
873#MD5SUM=$(searchtool md5sum)
Stefan Reinauer66e93352015-06-16 22:38:23 +0200874CHECKSUM=$SHA1SUM
Martin Roth95f7b222016-03-20 12:38:48 -0600875LBZIP2=$(searchtool lbzip2 "" nofail)
876PIGZ=$(searchtool pigz "" nofail)
Stefan Reinauer66e93352015-06-16 22:38:23 +0200877
878searchtool m4 > /dev/null
879searchtool bison > /dev/null
880searchtool flex flex > /dev/null
881searchtool g++ "Free Software Foundation" nofail > /dev/null || \
Marc Jones5ee69512015-06-17 15:38:17 -0600882searchtool clang "clang version" nofail > /dev/null || \
Martin Rothe3963172016-01-06 13:54:32 -0700883searchtool clang "LLVM" "" "g++" > /dev/null
Stefan Reinauer66e93352015-06-16 22:38:23 +0200884searchtool bzip2 "bzip2," > /dev/null
Nico Huber0ff3b392017-03-12 16:07:33 +0100885searchtool xz "XZ Utils" "" "xz-utils" > /dev/null
Stefan Reinauer66e93352015-06-16 22:38:23 +0200886
Patrick Georgidf1ff232017-01-07 09:28:43 +0100887if searchtool wget "GNU" nofail > /dev/null; then
888 download_showing_percentage() {
889 url=$1
890 printf " ..${red} 0%%"
891 wget $url 2>&1 | while read line; do
892 echo $line | grep -o "[0-9]\+%" | awk '{printf("\b\b\b\b%4s", $1)}'
893 done
894 echo "${NC}"
895 }
896elif searchtool curl "^curl " > /dev/null; then
897 download_showing_percentage() {
898 url=$1
899 echo
900 curl -#OL $url
901 }
902fi
903
Martin Roth591790f2016-03-20 20:39:04 -0600904check_for_library "-lz" "zlib (zlib1g-dev or zlib-devel)"
905
Nico Huber156d87c2016-09-20 12:59:53 +0200906CC=cc
907check_cc
908
Martin Roth88463822016-01-07 11:03:36 -0700909if [ "$HALT_FOR_TOOLS" -ne 0 ]; then
910 exit 1
911fi
912
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700913# This initial cleanup is useful when updating the toolchain script.
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000914
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700915if [ "$clean" = "1" ]; then
916 cleanup
917fi
Stefan Reinauer074d9132009-09-26 16:43:17 +0000918
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700919# Set up host compiler and flags needed for various OSes
Stefan Reinauer074d9132009-09-26 16:43:17 +0000920
Patrick Georgif2c15f52015-06-11 21:07:31 +0200921if is_package_enabled "GCC"; then
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700922if [ $UNAME = "Darwin" ]; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000923 #GCC_OPTIONS="$GCC_OPTIONS --enable-threads=posix"
924
925 # generally the OS X compiler can create x64 binaries.
926 # Per default it generated i386 binaries in 10.5 and x64
927 # binaries in 10.6 (even if the kernel is 32bit)
928 # For some weird reason, 10.5 autodetects an ABI=64 though
929 # so we're setting the ABI explicitly here.
Stefan Reinauerd7649122015-06-09 11:44:25 -0700930 if [ $(sysctl -n hw.optional.x86_64 2>/dev/null) -eq 1 ] 2>/dev/null; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000931 OPTIONS="ABI=64"
932 else
933 OPTIONS="ABI=32"
934 fi
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700935
Stefan Reinauer4266b922012-12-05 16:18:32 -0800936 # In Xcode 4.5.2 the default compiler is clang.
937 # However, this compiler fails to compile gcc 4.7.x. As a
938 # workaround it's possible to compile gcc with llvm-gcc.
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700939 if $CC -v 2>&1 | grep -q LLVM; then
Stefan Reinauer4266b922012-12-05 16:18:32 -0800940 CC=llvm-gcc
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700941 fi
zbao11f1d312015-08-05 23:15:54 -0400942elif [ $UNAME = "Linux" -o $UNAME = "Cygwin" ]; then
Patrick Georgiddb8f802015-07-04 17:45:54 +0200943 # gmp is overeager with detecting 64bit CPUs even if they run
944 # a 32bit kernel and userland.
945 if [ "$(uname -m 2>/dev/null)" = "i686" ]; then
946 OPTIONS="ABI=32"
947 fi
Nico Huberde45c592016-01-20 23:22:33 +0100948elif [ $UNAME = "NetBSD" ]; then
949 # same for NetBSD but this one reports an i386
950 if [ "$(uname -m 2>/dev/null)" = "i386" ]; then
951 OPTIONS="ABI=32"
952 fi
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000953fi
Nico Huber66c2c1a2016-09-20 13:09:29 +0200954if [ -z "${LANGUAGES}" ]; then
955 if hostcc_has_gnat1 && \
956 [ "$(hostcc_version)" = "$(buildcc_version)" -o "${BOOTSTRAP}" = "1" ];
957 then
958 printf "\nFound compatible Ada compiler, enabling Ada support by default.\n\n"
959 LANGUAGES="ada,${DEFAULT_LANGUAGES}"
960 else
961 LANGUAGES="${DEFAULT_LANGUAGES}"
962 fi
963fi
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700964fi # GCC
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000965
Nico Huber5f72f962016-01-31 23:05:19 +0100966export HOSTCFLAGS="-Os"
967if have_hostcflags_from_gmp; then
968 set_hostcflags_from_gmp
969fi
970
Patrick Georgic1a75b12011-11-04 21:37:14 +0100971if [ "$USECCACHE" = 1 ]; then
972 CC="ccache $CC"
973fi
974
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700975# Prepare target directory for building GCC
976# (dependencies must be in the PATH)
Stefan Reinauer16bd7892012-12-07 23:57:01 +0100977mkdir -p $DESTDIR$TARGETDIR/bin
Stefan Reinauer88352d72016-04-06 15:57:03 -0700978mkdir -p $DESTDIR$TARGETDIR/share
Stefan Reinauer16bd7892012-12-07 23:57:01 +0100979export PATH=$DESTDIR$TARGETDIR/bin:$PATH
980
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700981# Download, unpack, patch and build all packages
982
Martin Roth03625172016-02-17 14:44:14 -0700983printf "Downloading tarballs ... \n"
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700984mkdir -p tarballs
985for P in $PACKAGES; do
986 download $P
987done
Martin Roth03625172016-02-17 14:44:14 -0700988printf "Downloaded tarballs ... ${green}ok${NC}\n"
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700989
990printf "Unpacking and patching ... \n"
991for P in $PACKAGES; do
992 unpack_and_patch $P || exit 1
993done
994printf "Unpacked and patched ... ${green}ok${NC}\n"
995
996printf "Building packages ... \n"
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700997for package in $PACKAGES; do
998 build $package
999done
Stefan Reinauer5dd26352015-06-09 14:52:22 -07001000printf "Packages built ... ${green}ok${NC}\n"
Stefan Reinauer14ce2132015-06-05 13:01:13 -07001001
Stefan Reinauer699ac272015-06-05 12:43:28 -07001002# Adding git information of current tree to target directory
1003# for reproducibility
Stefan Reinauerd7649122015-06-09 11:44:25 -07001004PROGNAME=$(basename "$0")
Stefan Reinauer88352d72016-04-06 15:57:03 -07001005rm -f "$DESTDIR$TARGETDIR/share/$PROGNAME-*"
1006cp "$PROGNAME" "$DESTDIR$TARGETDIR/share/$PROGNAME-$CROSSGCC_VERSION-$CROSGCC_COMMIT"
Zheng Bao30b895f2013-02-06 18:04:40 +08001007
Stefan Reinauer88e83e52016-04-06 15:39:48 -07001008cleanup
Stefan Reinauer074d9132009-09-26 16:43:17 +00001009
Stefan Reinauer699ac272015-06-05 12:43:28 -07001010printf "\n${green}You can now run your $NAME toolchain from $TARGETDIR.${NC}\n"